using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MySql.Data.MySqlClient;

namespace MySQL_Tester
{
    public partial class MainWnd : Form
    {
        MySqlConnection cnn;

        public MainWnd()
        {
            InitializeComponent();
        }

        private void MainWnd_Load(object sender, EventArgs e)
        {
            txtSelect.Text = "SELECT name As Month, Max(date1) As 'Max Date', Min(date2) As 'Min Date'\r\nFROM times GROUP BY name ORDER BY 'Min Date';";
            txtTable.Text = "CREATE TABLE `times` (\r\n  `id` int(11) NOT NULL auto_increment,\r\n  `name` char(25) default NULL,\r\n  `date1` datetime default NULL,\r\n  `date2` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,\r\n  PRIMARY KEY  (`id`)\r\n);\r\n";
            txtInserted.Text = "INSERT INTO TIMES(name, date1, date2) VALUES('January', '2008-01-01 12:00:00', '2008-01-01 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('January', '2008-01-15 12:00:00', '2008-01-15 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('January', '2008-01-31 12:00:00', '2008-01-31 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('February', '2008-02-01 12:00:00', '2008-02-29 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('February', '2008-02-15 12:00:00', '2008-02-15 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('February', '2008-02-29 12:00:00', '2008-02-01 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('March', '2008-03-15 12:00:00', '2008-02-31 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('March', '2008-03-01 12:00:00', '2008-02-15 12:00:00');\r\nINSERT INTO TIMES(name, date1, date2) VALUES('March', '2008-03-31 12:00:00', '2008-02-01 12:00:00');\r\n";

            cnn = new MySqlConnection("Database=Pruebas;Data Source=localhost;User Id=root;Password=1;Port=3309");
            cnn.Open();
        }

        private void btnGetData_Click(object sender, EventArgs e)
        {
            MySqlCommand cmd = new MySqlCommand(txtSelect.Text, cnn);
            MySqlDataAdapter da = new MySqlDataAdapter(cmd);
            DataSet ds = new DataSet();
            da.Fill(ds);

            Boolean RowHaveArray;
            String TextResult = null;

            if (chkPrevents.Checked)
            {
                for (int row = 0; row < ds.Tables[0].Rows.Count; row++)
                {
                    RowHaveArray = false;
                    for (int columns = 0; columns < ds.Tables[0].Columns.Count; columns++)
                    {
                        if (ds.Tables[0].Rows[row].ItemArray[columns].GetType().ToString() == "System.Byte[]")
                        {
                            if (!RowHaveArray)
                            {
                                TextResult += String.Format("{2}The Row {0} have Byte[] in the column(s): {1}", row + 1, ds.Tables[0].Columns[columns].ColumnName, String.IsNullOrEmpty(TextResult) ? "" : "\r\n");
                                RowHaveArray = true;
                            }
                            else
                                TextResult += String.Format(", {0}", ds.Tables[0].Columns[columns].ColumnName);
                        }
                            ds.Tables[0].Rows[row].ItemArray[columns] = null;
                    }                    
                }
            }

            if (!String.IsNullOrEmpty(TextResult))
            {
                MessageBox.Show(this, TextResult, Application.ProductName);
                MySQLData.DataSource = null;
            }
            else
                MySQLData.DataSource = ds.Tables[0];
        }
    }
}